/* 
 * Copyright (c) 1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 */

#ifndef	_MACH_PARISC_RPC_H_
#define _MACH_PARISC_RPC_H_

typedef struct {
	integer_t	rpch_port;
	integer_t	rpch_id;
	integer_t	rpch_arg2;
	integer_t	rpch_arg3;
} rpc_header_t;

#define	rpch_rbuf	rpch_arg2	/* request (client-side) */
#define	rpch_rbufsize	rpch_arg3	/* request (client-side) */
#define	rpch_seqno	rpch_arg2	/* request (server-side) */
#define	rpch_moreacts	rpch_arg3	/* request (server-side) */

typedef struct {
	rpc_header_t		Head;
	int			Direct[8];
	mach_port_t		PortName;
	mach_msg_type_t		PortType;
	void *			MemAddr;
	int			MemSize;
} rpc_message_t;

typedef struct {
	vm_offset_t		entry_pc;
	vm_offset_t		entry_dp;
} rpc_info_t;

#define PARISC_RPC_INFO_COUNT	(sizeof(rpc_info_t) / sizeof(int))

#endif /* _MACH_PARISC_RPC_H_ */
