/* 
 * Copyright (c) 1990, 1991, 1992, 1994, The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: thread_status.h 1.11 94/12/14$
 */

#ifndef	_MACH_PARISC_THREAD_STATUS_H_
#define _MACH_PARISC_THREAD_STATUS_H_

/*
 * parisc_thread_state is the structure that is exported to user threads for 
 * use in status/mutate calls.  This structure should never change.
 */

#define PARISC_THREAD_STATE 1

struct parisc_thread_state {
	unsigned flags;
	unsigned r1;
	unsigned r2;			/* rp */
	unsigned r3;
	unsigned r4;
	unsigned r5;
	unsigned r6;
	unsigned r7;
	unsigned r8;
	unsigned r9;
	unsigned r10;
	unsigned r11;
	unsigned r12;
	unsigned r13;
	unsigned r14;
	unsigned r15;
	unsigned r16;
	unsigned r17;
	unsigned r18;
	unsigned r19;
	unsigned r20;
	unsigned r21;
	unsigned r22;
	unsigned r23;			/* arg3 */
	unsigned r24;			/* arg2 */
	unsigned r25;			/* arg1 */
	unsigned r26;			/* arg0 */
	unsigned r27;			/* dp   */
	unsigned r28;			/* ret0 */
	unsigned r29;			/* ret1 */
	unsigned r30;			/* sp   */
	unsigned r31;
	unsigned cr11;			/* sar  */
	unsigned iioq_head;
	unsigned iisq_head;
	unsigned iioq_tail;
	unsigned iisq_tail;
	unsigned cr15;
	unsigned cr19;
	unsigned cr20;
	unsigned cr21;
	unsigned cr22;			/* ipsw */
	unsigned bsd_goto;		/* not used in Mach */
	unsigned sr4;
	unsigned sr0;
	unsigned sr1;
	unsigned sr2;
	unsigned sr3;
	unsigned sr5;
	unsigned sr6;
	unsigned sr7;
	unsigned cr0;
	unsigned cr8;
	unsigned cr9;
	unsigned cr10;			/* not used in Mach */
	unsigned cr12;
	unsigned cr13;
	unsigned cr24;			/* not used in Mach */
	unsigned cr25;			/* not used in Mach */
	unsigned cr26;			/* not used in Mach */
	unsigned mpsfu_high;		/* not used in Mach */
	unsigned mpsfu_low;		/* not used in Mach */
	unsigned mpsfu_ovflo;		/* not used in Mach */
	int pad;
	double	fr0;
	double	fr1;
	double	fr2;
	double	fr3;
	double	fr4;
	double	fr5;
	double	fr6;
	double	fr7;
	double	fr8;
	double	fr9;
	double	fr10;
	double	fr11;
	double	fr12;
	double	fr13;
	double	fr14;
	double	fr15;
	double	fr16;
	double	fr17;
	double	fr18;
	double	fr19;
	double	fr20;
	double	fr21;
	double	fr22;
	double	fr23;
	double	fr24;
	double	fr25;
	double	fr26;
	double	fr27;
	double	fr28;
	double	fr29;
	double	fr30;
	double	fr31;
};

/*
 * Save State Flags
 */
#define	SS_INTRAP	0x01	/* State saved from trap */
#define	SS_INSYSCALL	0x02	/* State saved from system call */
#define SS_ININT	0x04	/* On the interrupt stack */
#define	SS_PSPKERNEL	0x08	/* Previous context stack pointer kernel */
#define	SS_RFIRETURN	0x10	/* Must RFI from syscall to restore
				   complete user state (i.e. sigreturn) */

#define	SS_INTRAP_POS	 31	/* State saved from trap */
#define	SS_INSYSCALL_POS 30	/* State saved from system call */
#define SS_ININT_POS	 29	/* On the interrupt stack */
#define	SS_PSPKERNEL_POS 28	/* Previous context stack pointer kernel */
#define	SS_RFIRETURN_POS 27	/* RFI from syscall */

#define PARISC_THREAD_STATE_COUNT \
   (sizeof(struct parisc_thread_state) / sizeof(int))

#endif /* _MACH_PARISC_THREAD_STATUS_H_ */
