/*
 * Copyright (c) 1993,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */
/*
 *	File:	current.h
 *
 *	How to find the current hair, task, thread, processor, etc.
 *	This is a separate file mainly because putting these macros in the "relevant" places
 *	would require tons of otherwise-unnecessary cross-includes,
 *	and not everything needs these.
 *
 */
/* XXX all of these should be gotten rid of */

#ifndef	_KERN_CURRENT_H_
#define _KERN_CURRENT_H_

#include <kern/thread.h>
#include <kern/act.h>
#include <kern/task.h>
#include <machine/current.h>

#ifndef CURRENT_TASK
#define	current_task()		(current_act()->task)
#endif

#ifndef CURRENT_SPACE
#define	current_space()		(current_task()->itk_space)
#endif

#ifndef CURRENT_MAP
#define	current_map()		(current_task()->map)
#endif

#endif
