/* 
 * Copyright (c) 1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

#include <string.h>

#define BUF_SIZE 1024

static unsigned char buf[BUF_SIZE];
static unsigned int ofs = 0;

void console_buf_cnputc(unsigned char c)
{
	if (ofs >= BUF_SIZE)
	{
		int i;

		/* Console buffer is full - remove a line from the beginning.  */
		for (i = 0; ; i++)
		{
			if (i >= BUF_SIZE)
			{
				ofs = 0;
				break;
			}
			if (buf[i] == '\n')
			{
				i++;
				ofs -= i;
				memcpy(buf, buf+i, ofs);
				break;
			}
		}
	}

	buf[ofs++] = c;
}

int console_buf_cnmaygetc(void)
{
	return -1;
}

const char *console_buf_get(void)
{
	buf[ofs] = 0;
	return buf;
}

